#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

const long BOUND = 65535;
const long MAX_POW = 15;

typedef short Digit;
const Digit UNDEF = 100;

typedef Digit DigitArr[2*BOUND+1];

DigitArr digits[MAX_POW+1];

inline Digit Get(DigitArr arr, int index)
{
	return arr[index + BOUND];
}

inline void Set(DigitArr arr, int index, int value)
{
	arr[index+BOUND] = value;
}

int main(void)
{
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	long base, minDigit, maxDigit, number;
	long iCase = 0;

	while (scanf("%ld %ld %ld", &base, &minDigit, &number) == 3)
	{
		++iCase;
		maxDigit = minDigit + base - 1;

		long curBase = 1;
		long pow, iNumber, iDigit;

		for (pow = 0; pow <= MAX_POW; ++pow)
			for (iNumber = -BOUND; iNumber <= BOUND; ++iNumber)
				Set(digits[pow], iNumber, UNDEF);




		for (iDigit = minDigit; iDigit <= maxDigit; ++iDigit)
		{
			Set(digits[1], iDigit*curBase, iDigit);
		}


		curBase *= base;

		for (pow = 1; 
				curBase < 3*BOUND && Get(digits[pow], number) == UNDEF && pow < MAX_POW; 
				++pow)
		{
			for (iNumber = -BOUND; iNumber <= BOUND; ++iNumber)
			{
				if (Get(digits[pow], iNumber) != UNDEF)
				{
					for (iDigit = minDigit; iDigit <= maxDigit; ++iDigit)
					{
						if (labs(iNumber + iDigit*curBase) <= BOUND)
						{
							if (Get(digits[pow+1], iNumber + iDigit*curBase) > iDigit)
							{
								Set(digits[pow+1], iNumber+iDigit*curBase, iDigit);
							}
						}
					}
				}
			}
			curBase *= base;
		}

		printf("CASE# %ld:\n", iCase);

		if (Get(digits[pow], number) != UNDEF)
		{
			long oldNum = number;
			for (; pow > 0; --pow)
			{
				curBase /= base;
				iDigit = Get(digits[pow], number);
				printf ("%s%ld*%ld^%ld", iDigit>=0?"+":"-", labs(iDigit), base, pow-1);
				number -= iDigit*curBase;
			}
			printf(" = %ld\n", oldNum);
		}
		else
		{
			puts("NOT REPRESENTABLE");
		}

	}


#ifndef ONLINE_JUDGE
	fclose(stdout);
	fclose(stdin);
#endif

	return 0;
}